
// automatically generated by m4 from headers in proto subdir


#ifndef _MATH_H
#define _MATH_H

// THE SELECTED FLOATING POINT PACKAGE MAY NOT SUPPORT ALL LISTED FUNCTIONS

#ifndef _FLOAT_T_DEFINED
#define _FLOAT_T_DEFINED

   #ifdef __CLANG
   
   typedef float float_t;
   
   #endif

   #ifdef __SDCC
   
   typedef float float_t;
   
   #endif
   
   #ifdef __SCCZ80
   
   typedef double float_t;
   
   #endif
   
#endif

#ifndef _DOUBLE_T_DEFINED
#define _DOUBLE_T_DEFINED

   #ifdef __CLANG
   
   typedef float double_t;
   
   #endif

   #ifdef __SDCC
   
   typedef float double_t;
   
   #endif
   
   #ifdef __SCCZ80
   
   typedef double double_t;
   
   #endif
   
#endif

// XSI EXTENSION
// temporary : math lib should supply these via func call

#define M_E                    2.718281828459
#define M_LOG2E                1.442695040889
#define M_LOG10E               0.4342944819033
#define M_LN2                  0.693147180560
#define M_LN10                 2.302585092994
#define M_PI                   3.141592653590
#define M_PI_2                 1.570796326795
#define M_PI_4                 0.7853981633974
#define M_1_PI                 0.3183098861838
#define M_2_PI                 0.6366197723676
#define M_2_SQRTPI             1.128379167096
#define M_SQRT2                1.414213562373
#define M_SQRT1_2              0.7071067811865

//

#define FLT_EVAL_METHOD        1
#define MATH_ERRNO             1
#define MATH_ERREXCEPT         2
#define math_errhandling       1

#ifdef __CLANG

#define HUGE_VAL               1.7014117331E+38
#define HUGE_VALF              1.7014117331E+38
#define INFINITY               1.7014117331E+38

#endif

#ifdef __SDCC

#define HUGE_VAL               1.7014117331E+38
#define HUGE_VALF              1.7014117331E+38
#define INFINITY               1.7014117331E+38

#endif

#ifdef __SCCZ80

#define HUGE_VAL               1.7014118346E+38
#define HUGE_VALF              1.7014118346E+38
#define INFINITY               1.7014118346E+38

#endif

extern double_t acos(double_t x);


extern double_t asin(double_t x);


extern double_t atan(double_t x);


extern double_t atan2(double_t y,double_t x);



extern double_t cos(double_t x);


extern double_t sin(double_t x);


extern double_t tan(double_t x);



extern double_t acosh(double_t x);


extern double_t asinh(double_t x);


extern double_t atanh(double_t x);



extern double_t cosh(double_t x);


extern double_t sinh(double_t x);


extern double_t tanh(double_t x);



extern double_t exp(double_t x);


extern double_t exp2(double_t x);


extern double_t expm1(double_t x);


extern double_t frexp(double_t value,int *exp);


extern int ilogb(double_t x);


extern double_t ldexp(double_t x,int exp);



extern double_t log(double_t x);


extern double_t log10(double_t x);


extern double_t log1p(double_t x);


extern double_t log2(double_t x);


extern double_t logb(double_t x);



extern double_t scalbn(double_t x,int n);


extern double_t scalbln(double_t x,int n);



extern double_t fabs(double_t x);


extern double_t hypot(double_t x,double_t y);



extern double_t pow(double_t x,double_t y);


extern double_t sqrt(double_t x);


extern double_t cbrt(double_t x);



extern double_t erf(double_t x);


extern double_t erfc(double_t x);


extern double_t lgamma(double_t x);


extern double_t tgamma(double_t x);



extern double_t ceil(double_t x);


extern double_t floor(double_t x);


extern double_t nearbyint(double_t x);


extern double_t rint(double_t x);


extern long lrint(double_t x);


extern double_t round(double_t x);


extern long lround(double_t x);


extern double_t trunc(double_t x);



extern double_t modf(double_t value,double_t *iptr);


extern double_t fmod(double_t x,double_t y);


extern double_t remainder(double_t x,double_t y);


extern double_t remquo(double_t x,double_t y,int *quo);



extern double_t copysign(double_t x,double_t y);


extern double_t nan(const char *tagp);



extern double_t nextafter(double_t x,double_t y);


extern double_t nexttoward(double_t x,double_t y);



extern double_t fdim(double_t x,double_t y);



extern double_t fmax(double_t x,double_t y);


extern double_t fmin(double_t x,double_t y);



extern double_t fma(double_t x,double_t y,double_t z);



extern int isgreater(double_t x,double_t y);


extern int isgreaterequal(double_t x,double_t y);


extern int isless(double_t x,double_t y);


extern int islessequal(double_t x,double_t y);


extern int islessgreater(double_t x,double_t y);


extern int isunordered(double_t x,double_t y);



// NO DISTINCTION BETWEEN FLOAT AND DOUBLE

#define acosf        acos
#define asinf        asin
#define atanf        atan
#define atan2f       atan2

#define cosf         cos
#define sinf         sin
#define tanf         tan

#define acoshf       acosh
#define asinhf       asinh
#define atanhf       atanh

#define coshf        cosh
#define sinhf        sinh
#define tanhf        tanh

#define expf         exp
#define exp2f        exp2
#define expm1f       expm1
#define frexpf       frexp
#define ilogbf       ilogb
#define ldexpf       ldexp

#define logf         log
#define log10f       log10
#define log1pf       log1p
#define log2f        log2
#define logbf        logb

#define scalbnf      scalbn
#define scalblnf     scalbln

#define fabsf        fabs
#define hypotf       hypot

#define powf         pow
#define sqrtf        sqrt
#define cbrtf        cbrt

#define erff         erf
#define erfcf        erfc
#define lgammaf      lgamma
#define tgammaf      tgamma

#define ceilf        ceil
#define floorf       floor
#define nearbyintf   nearbyint
#define rintf        rint
#define lrintf       lrint
#define llrintf      llrint
#define roundf       round
#define lroundf      lround
#define llroundf     llround
#define truncf       trunc

#define modff        modf
#define fmodf        fmod
#define remainderf   remainder
#define remquof      remquo

#define copysignf    copysign
#define nanf         nan

#define nextafterf   nextafter
#define nexttowardf  nexttoward

#define fdimf        fdim

#define fmaxf        fmax
#define fminf        fmin

#define fmaf         fma

#endif
