
// automatically generated by m4 from headers in proto subdir


#ifndef _INTRINSIC_H
#define _INTRINSIC_H

#ifdef __SDCC

// disable warnings connected to intrinsics

#pragma disable_warning 84
#pragma disable_warning 112

#endif

#ifdef __CLANG

#define intrinsic_label(name)  { extern void intrinsic_label_##name(void); intrinsic_label_##name(); }
#define intrinsic_load16(address)  ((unsigned int)intrinsic_load16_##address())
#define intrinsic_store16(address,value)  ((unsigned int)(intrinsic_store16_address_##address(),intrinsic_store16_value_##value()))

#define intrinsic_in8(port)  ((unsigned char)intrinsic_in8_port_##port())
#define intrinsic_out8(port,value)  ((unsigned char)(intrinsic_out8_port_##port(),intrinsic_out8_value_##value()))
#define intrinsic_in16(port)  ((unsigned char)intrinsic_in16_port_##port())
#define intrinsic_out16(port,value)  ((unsigned char)(intrinsic_out16_port_##port(),intrinsic_out16_value_##value()))

#endif

#ifdef __SDCC

#define intrinsic_label(name)  { extern void intrinsic_label_##name(void) __preserves_regs(a,b,c,d,e,h,l); intrinsic_label_##name(); }
#define intrinsic_load16(address)  ((unsigned int)intrinsic_load16_##address())
#define intrinsic_store16(address,value)  ((unsigned int)(intrinsic_store16_address_##address(),intrinsic_store16_value_##value()))

#define intrinsic_in8(port)  ((unsigned char)intrinsic_in8_port_##port())
#define intrinsic_out8(port,value)  ((unsigned char)(intrinsic_out8_port_##port(),intrinsic_out8_value_##value()))
#define intrinsic_in16(port)  ((unsigned char)intrinsic_in16_port_##port())
#define intrinsic_out16(port,value)  ((unsigned char)(intrinsic_out16_port_##port(),intrinsic_out16_value_##value()))

#endif

#ifdef __SCCZ80

#define intrinsic_label(name)  asm("name:");
#define intrinsic_load16(address)  ((unsigned int)intrinsic_load16_##address())
#define intrinsic_store16(address,value)  ((unsigned int)(intrinsic_store16_address_##address(),intrinsic_store16_value_##value()))

#define intrinsic_in8(port)  ((unsigned char)intrinsic_in8_port_##port())
#define intrinsic_out8(port,value)  ((unsigned char)(intrinsic_out8_port_##port(),intrinsic_out8_value_##value()))
#define intrinsic_in16(port)  ((unsigned char)intrinsic_in16_port_##port())
#define intrinsic_out16(port,value)  ((unsigned char)(intrinsic_out16_port_##port(),intrinsic_out16_value_##value()))

#endif

extern void intrinsic_stub(void) __preserves_regs(a,b,c,d,e,h,l);


extern void intrinsic_di(void) __preserves_regs(a,b,c,d,e,h,l);

extern void intrinsic_ei(void) __preserves_regs(a,b,c,d,e,h,l);

extern void intrinsic_halt(void) __preserves_regs(a,b,c,d,e,h,l);

extern void intrinsic_reti(void) __preserves_regs(a,b,c,d,e,h,l);

extern void intrinsic_retn(void) __preserves_regs(a,b,c,d,e,h,l);

extern void intrinsic_im_0(void) __preserves_regs(a,b,c,d,e,h,l);

extern void intrinsic_im_1(void) __preserves_regs(a,b,c,d,e,h,l);

extern void intrinsic_im_2(void) __preserves_regs(a,b,c,d,e,h,l);

extern void intrinsic_nop(void) __preserves_regs(a,b,c,d,e,h,l);

extern void intrinsic_push_af(void) __preserves_regs(a,b,c,d,e,h,l);

extern void intrinsic_push_bc(void) __preserves_regs(a,b,c,d,e,h,l);

extern void intrinsic_push_de(void) __preserves_regs(a,b,c,d,e,h,l);

extern void intrinsic_push_hl(void) __preserves_regs(a,b,c,d,e,h,l);

extern void intrinsic_push_ix(void) __preserves_regs(a,b,c,d,e,h,l);

extern void intrinsic_push_iy(void) __preserves_regs(a,b,c,d,e,h,l);

extern void intrinsic_pop_af(void) __preserves_regs(b,c,d,e,h,l);

extern void intrinsic_pop_bc(void) __preserves_regs(a,d,e,h,l);

extern void intrinsic_pop_de(void) __preserves_regs(a,b,c,h,l);

extern void intrinsic_pop_hl(void) __preserves_regs(a,b,c,d,e);

extern void intrinsic_pop_ix(void) __preserves_regs(a,b,c,d,e,h,l);

extern void intrinsic_pop_iy(void) __preserves_regs(a,b,c,d,e,h,l);


extern void intrinsic_ex_de_hl(void) __preserves_regs(a,b,c);

extern void intrinsic_exx(void) __preserves_regs(a);


extern void *intrinsic_return_bc(void) __preserves_regs(a,b,c,d,e);

extern void *intrinsic_return_de(void) __preserves_regs(a,b,c,d,e);


extern unsigned int intrinsic_swap_endian_16(unsigned long n) __preserves_regs(b,c,d,e);
extern unsigned int intrinsic_swap_endian_16_fastcall(unsigned long n) __preserves_regs(b,c,d,e) __z88dk_fastcall;
#define intrinsic_swap_endian_16(a) intrinsic_swap_endian_16_fastcall(a)


extern unsigned long intrinsic_swap_endian_32(unsigned long n) __preserves_regs(b,c);
extern unsigned long intrinsic_swap_endian_32_fastcall(unsigned long n) __preserves_regs(b,c) __z88dk_fastcall;
#define intrinsic_swap_endian_32(a) intrinsic_swap_endian_32_fastcall(a)


extern unsigned long intrinsic_swap_word_32(unsigned long n) __preserves_regs(a,b,c);
extern unsigned long intrinsic_swap_word_32_fastcall(unsigned long n) __preserves_regs(a,b,c) __z88dk_fastcall;
#define intrinsic_swap_word_32(a) intrinsic_swap_word_32_fastcall(a)



#endif
